apiVersion: batch/v1
kind: Job
metadata:
  name: {{ include "gemeente-stijns.fullname" . }}-create-services
  labels:
    {{- include "gemeente-stijns.labels" . | nindent 4 }}
  annotations:
    helm.sh/hook: post-install,post-upgrade
    helm.sh/hook-weight: "2"
    helm.sh/hook-delete-policy: "before-hook-creation,hook-succeeded"
spec:
  template:
    metadata:
      labels:
        {{- include "gemeente-stijns.selectorLabels" . | nindent 8 }}
    spec:
      restartPolicy: OnFailure
      containers:
        - name: curl
          image: {{ printf "%s/%s:%s" .Values.createServices.image.registry .Values.createServices.image.repository .Values.createServices.image.tag }}
          imagePullPolicy: {{ .Values.createServices.image.pullPolicy }}
          command: ["/bin/sh"]
          args:
            - -c
            - |
              curl --fail-with-body --cert  /certificate/tls.crt --key /certificate/tls.key --cacert /config/root.pem {{ .Values.createServices.controllerAPIAddress  }}/v1/services --data $SERVICE_JSON > error.txt || grep "service name is already in use" error.txt || (cat error.txt && exit 1)
          volumeMounts:
            - name: certificate
              mountPath: /certificate
              readOnly: true
            - name: config
              mountPath: /config
              readOnly: true
          env:
            - name: SERVICE_JSON
              value: {{ .Values.createServices.parkeerrechten | toJson | quote }}
      volumes:
        - name: certificate
          secret:
            secretName: gemeente-stijns-manager-internal-tls
            defaultMode: 0644
        - name: config
          configMap:
            name: {{ template "gemeente-stijns.fullname" . }}-create-services
